template< typename Coordinate >
class ConstGravityForceFunctor
{
  double f_value;

public: 
  typedef Coordinate Coord;
  ConstGravityForceFunctor(double f_value_) : f_value(f_value_)
  {}

  Coordinate operator()(const Coordinate & ) const
  {
    Coordinate x(0);
    x[1]=-f_value;
    return x;
  }
};

template< typename Coordinate >
class CentralPickForceFunctor
{
  double f_value;
  double L;

public: 
  typedef Coordinate Coord;

  CentralPickForceFunctor(double f_value_, double L_) : f_value(f_value_), L(L_)
  {}

  Coordinate operator()(const Coordinate & x) const 
  {
    Coordinate f(0);
    if( std::abs(x[0] - L*0.5) < L*0.1)
      f[1]=-f_value;
    return f;
  }
};

