#ifndef STRING_J_ASSEMBLER_HH
#define STRING_J_ASSEMBLER_HH

template <typename Rhs, typename ForceFunctor>
void assembleRhs(Rhs & rhs, const Rhs & vertices, const ForceFunctor & f, const int dim)
{
  // Initialize right hand side of linear system. Remember that
  // trivial problems have to be set for the first and the last node's
  // coordinates.
}

// Assemble system matrix of string chain system. Remember that
// trivial problems have to be set for the first and the last node's
// coordinates.
template<typename Matrix, typename ScalarData, int dim>
void assembleMatrix(Matrix & A, const ScalarData & u, 
                    const ScalarData & kappa, const ScalarData & lengths)
{

  typedef typename ScalarData::value_type ctype;

  const unsigned int N = u.size() / dim - 1;

  // Get row iterators
  typename Matrix::RowIterator rit = A.begin();
  typename Matrix::RowIterator erit = A.end();
  for(; rit!=erit; ++rit){
    const int ri = rit.index();

    // Get column iterators
    typename Matrix::ColIterator cit = rit->begin();
    typename Matrix::ColIterator ecit = rit->end();

    // Iterate columns
    for(; cit != ecit; ++cit){
      const int ci = cit.index();
      
      // *cit = some value
    }
  }
}

#endif
